aboutsummaryrefslogtreecommitdiff
path: root/scripts/git/git-push-all.sh
diff options
context:
space:
mode:
authorteor <teor@torproject.org>2019-08-09 00:18:56 +1000
committerteor <teor@torproject.org>2019-08-29 22:47:43 +1000
commit667311ebbd6fe6c43da8eb5abc1e34e30fb5b911 (patch)
tree3093dfe484660c58bfa9eb87544f748efd45198e /scripts/git/git-push-all.sh
parentc98724b0228b892b738f503434bdc28463ba488c (diff)
downloadtor-667311ebbd6fe6c43da8eb5abc1e34e30fb5b911.tar.gz
tor-667311ebbd6fe6c43da8eb5abc1e34e30fb5b911.zip
scripts/git: Add test branch support to the git scripts
Add a -t <test-branch-prefix> argument to git-merge-forward.sh and git-push-all.sh, which makes these scripts create, merge forward, and push test branches. Add a -r <remote-name> argument to git-push-all.sh, so the script can push test branches to a personal remote. Closes ticket 31314.
Diffstat (limited to 'scripts/git/git-push-all.sh')
-rwxr-xr-xscripts/git/git-push-all.sh94
1 files changed, 85 insertions, 9 deletions
diff --git a/scripts/git/git-push-all.sh b/scripts/git/git-push-all.sh
index 617f24cdc5..f3bbe8b778 100755
--- a/scripts/git/git-push-all.sh
+++ b/scripts/git/git-push-all.sh
@@ -1,6 +1,6 @@
#!/usr/bin/env bash
-# Usage: git-push-all.sh <git-opts>
+# Usage: git-push-all.sh -t <test-branch-prefix> -r <remote-name> <git-opts>
# env vars: TOR_UPSTREAM_REMOTE_NAME=upstream TOR_PUSH_DELAY=0
# git-opts: --no-atomic --dry-run (any other git push option)
#
@@ -17,10 +17,49 @@ set -e
# Don't change this configuration - set the env vars in your .profile
#
# The upstream remote which git.torproject.org/tor.git points to.
+# In test branch mode, override this setting with -r <remote-name>
UPSTREAM_REMOTE=${TOR_UPSTREAM_REMOTE_NAME:-"upstream"}
# Add a delay between pushes, so CI runs on the most important branches first
PUSH_DELAY=${TOR_PUSH_DELAY:-0}
+#######################
+# Argument processing #
+#######################
+
+# Controlled by the -t <test-branch-prefix> option. The test branch base
+# name option makes git-merge-forward.sh create new test branches:
+# <tbbn>_029, <tbbn>_035, ... , <tbbn>_master, and merge forward.
+TEST_BRANCH_PREFIX=
+
+while getopts ":r:t:" opt; do
+ case "$opt" in
+ r) UPSTREAM_REMOTE="$OPTARG"
+ echo " *** PUSHING TO REMOTE: ${UPSTREAM_REMOTE} ***"
+ shift
+ shift
+ OPTIND=$[$OPTIND - 2]
+ ;;
+ t) TEST_BRANCH_PREFIX="$OPTARG"
+ echo " *** PUSHING TEST BRANCHES: ${TEST_BRANCH_PREFIX}_nnn ***"
+ shift
+ shift
+ OPTIND=$[$OPTIND - 2]
+ ;;
+ *)
+ # Assume git push will handle the option
+ ;;
+ esac
+done
+
+if [ "$TEST_BRANCH_PREFIX" ]; then
+ if [ "$UPSTREAM_REMOTE" = ${TOR_UPSTREAM_REMOTE_NAME:-"upstream"} ]; then
+ echo "Pushing test branches ${TEST_BRANCH_PREFIX}_nnn to " \
+ "$UPSTREAM_REMOTE is not allowed."
+ echo "Usage: $0 -r <remote-name> -t <test-branch-prefix> <git-opts>"
+ exit 1
+ fi
+fi
+
########################
# Git branches to push #
########################
@@ -33,6 +72,32 @@ PUSH_BRANCHES=$(echo \
{release,maint}-0.2.9 \
)
+if [ -z "$TEST_BRANCH_PREFIX" ]; then
+
+ # maint/release push mode
+ #
+ # List of branches to push. Ordering is not important.
+ PUSH_BRANCHES=$(echo \
+ master \
+ {release,maint}-0.4.1 \
+ {release,maint}-0.4.0 \
+ {release,maint}-0.3.5 \
+ {release,maint}-0.2.9 \
+ )
+else
+
+ # Test branch mode: merge to maint only, and create a new branch for 0.2.9
+ #
+ # List of branches to push. Ordering is not important.
+ PUSH_BRANCHES=$(echo \
+ ${TEST_BRANCH_PREFIX}_master \
+ ${TEST_BRANCH_PREFIX}_041 \
+ ${TEST_BRANCH_PREFIX}_040 \
+ ${TEST_BRANCH_PREFIX}_035 \
+ ${TEST_BRANCH_PREFIX}_029 \
+ )
+fi
+
###############
# Entry point #
###############
@@ -48,18 +113,29 @@ if [ "$PUSH_DELAY" -le 0 ]; then
else
PUSH_BRANCHES=$(echo "$PUSH_BRANCHES" | tr " " "\n" | sort -V)
MASTER_BRANCH=$(echo "$PUSH_BRANCHES" | tr " " "\n" | grep master)
- MAINT_BRANCHES=$(echo "$PUSH_BRANCHES" | tr " " "\n" | grep maint)
- RELEASE_BRANCHES=$(echo "$PUSH_BRANCHES" | tr " " "\n" | grep release | \
- tr "\n" " ")
- printf "Pushing with %ss delays, so CI runs in this order:\n%s\n%s\n%s\n" \
- "$PUSH_DELAY" "$MASTER_BRANCH" "$MAINT_BRANCHES" "$RELEASE_BRANCHES"
+ if [ -z "$TEST_BRANCH_PREFIX" ]; then
+ MAINT_BRANCHES=$(echo "$PUSH_BRANCHES" | tr " " "\n" | grep maint)
+ RELEASE_BRANCHES=$(echo "$PUSH_BRANCHES" | tr " " "\n" | grep release | \
+ tr "\n" " ")
+ printf "Pushing with %ss delays, so CI runs in this order:\n%s\n%s\n%s\n" \
+ "$PUSH_DELAY" "$MASTER_BRANCH" "$MAINT_BRANCHES" "$RELEASE_BRANCHES"
+ else
+ # Actually test branches based on maint branches
+ MAINT_BRANCHES=$(echo "$PUSH_BRANCHES" | tr " " "\n" | grep -v master)
+ printf "Pushing with %ss delays, so CI runs in this order:\n%s\n%s\n" \
+ "$PUSH_DELAY" "$MASTER_BRANCH" "$MAINT_BRANCHES"
+ # No release branches
+ RELEASE_BRANCHES=
+ fi
git push "$@" "$UPSTREAM_REMOTE" "$MASTER_BRANCH"
sleep "$PUSH_DELAY"
# shellcheck disable=SC2086
for b in $MAINT_BRANCHES; do
- git push "$@" "$UPSTREAM_REMOTE" $b
+ git push "$@" "$UPSTREAM_REMOTE" "$b"
sleep "$PUSH_DELAY"
done
- # shellcheck disable=SC2086
- git push --atomic "$@" "$UPSTREAM_REMOTE" $RELEASE_BRANCHES
+ if [ "$RELEASE_BRANCHES" ]; then
+ # shellcheck disable=SC2086
+ git push --atomic "$@" "$UPSTREAM_REMOTE" $RELEASE_BRANCHES
+ fi
fi